/*
    PIP - Platform Independent Primitives
    Distance units
    Ivan Pelipenko peri4ko@yandex.ru

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "piunits_class_distance.h"


PIString PIUnits::Class::Distance::name(int type) const {
	switch (type) {
	case Meter: return "meter"_tr("PIUnitsDistance");
	case Inch: return "inch"_tr("PIUnitsDistance");
	case Mil: return "mil"_tr("PIUnitsDistance");
	case Foot: return "foot"_tr("PIUnitsDistance");
	case Yard: return "yard"_tr("PIUnitsDistance");
	case Angstrom: return "angstrom"_tr("PIUnitsDistance");
	case AstronomicalUnit: return "astronomical unit"_tr("PIUnitsDistance");
	}
	return Class::Internal::unknown;
}


PIString PIUnits::Class::Distance::unit(int type) const {
	switch (type) {
	case Meter: return "m"_tr("PIUnitsDistance");
	case Inch: return "\""_tr("PIUnitsDistance");
	case Mil: return "thou"_tr("PIUnitsDistance");
	case Foot: return "ft"_tr("PIUnitsDistance");
	case Yard: return "yd"_tr("PIUnitsDistance");
	case Angstrom: return "Å"_tr("PIUnitsDistance");
	case AstronomicalUnit: return "au"_tr("PIUnitsDistance");
	}
	return Class::Internal::unknown;
}


double PIUnits::Class::Distance::convert(double v, int from, int to) const {
	static constexpr double inch_to_m              = 0.254;
	static constexpr double mil_to_m               = 0.254 * 1E-3;
	static constexpr double foot_to_m              = 0.3048;
	static constexpr double yard_to_m              = 0.9144;
	static constexpr double angstrom_to_m          = 1E-10;
	static constexpr double astronomical_unit_to_m = 149597870700.;
	double m                                       = v;
	switch (from) {
	case Inch: m *= inch_to_m; break;
	case Mil: m *= mil_to_m; break;
	case Foot: m *= foot_to_m; break;
	case Yard: m *= yard_to_m; break;
	case Angstrom: m *= angstrom_to_m; break;
	case AstronomicalUnit: m *= astronomical_unit_to_m; break;
	}
	switch (to) {
	case Inch: m /= inch_to_m; break;
	case Mil: m /= mil_to_m; break;
	case Foot: m /= foot_to_m; break;
	case Yard: m /= yard_to_m; break;
	case Angstrom: m /= angstrom_to_m; break;
	case AstronomicalUnit: m /= astronomical_unit_to_m; break;
	}
	return m;
}


PIString PIUnits::Class::Distance::valueToString(double v, char format, int prec) const {
	return PIString::fromNumber(v, format, prec);
}


bool PIUnits::Class::Distance::supportPrefixes(int type) const {
	return type == Meter;
}


bool PIUnits::Class::Distance::supportPrefixesNon3(int type) const {
	return type == Meter;
}


bool PIUnits::Class::Distance::supportPrefixesGreater(int type) const {
	return ClassBase::supportPrefixesGreater(type);
}


bool PIUnits::Class::Distance::supportPrefixesSmaller(int type) const {
	return ClassBase::supportPrefixesSmaller(type);
}
